import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.IOException;
import java.util.Hashtable;

public class CrawlerThread extends Thread {

    public CrawlerThread(){

    }

    @Override
    public void run() {

        String pageUrl = "https://www.otomoto.pl/osobowe/?search%5Bfilter_enum_has_registration%5D=1&search%5Bfilter_enum_damaged%5D=0&search%5Bfilter_enum_registered%5D=1&search%5Bfilter_enum_no_accident%5D=1&search%5Border%5D=filter_float_price%3Aasc&search%5Bbrand_program_id%5D%5B0%5D=&search%5Bcountry%5D=&page=";
        for (int i = 1; i <= 500; i++) {
            Document doc = null;
            System.out.println("Strona nr: " + i);
            String targetUrl = pageUrl + Integer.valueOf(i);
            System.out.println("Link: " + targetUrl);
            Boolean success = false; //flaga do sprawdzania czy udało sie połączyc
            while (!success) {
                success = true;
                try {
                    doc = Jsoup.connect(targetUrl).get();
                } catch (IOException e) {
                    System.out.println("Nie udalo sie polaczyc. " + e.getMessage());
                    success = false;
                }
            }

            Elements links = doc.select("a.offer-title__link");

            for (Element element : links) {
                Element photoDiv = element.parent().parent().parent().parent().selectFirst("div").selectFirst("span");
//                System.out.println("Promowana: " + photoDiv);
                if (photoDiv == null) { //todo sprawdzać czy oferta jest promowana
                    String url = element.attr("href");
                    System.out.println("Pobieram: " + url);
                    Document pageDoc = null;
                    success = false; //flaga do sprawdzania czy udało sie połączyc
                    while (!success) {
                        success = true;
                        try {
                            pageDoc = Jsoup.connect(url).get();
                        } catch (IOException e) {
                            System.out.println("Nie udalo sie polaczyc. " + e.getMessage());
                            success = false;
                        }
                    }
                    Elements offerParamsList = pageDoc.select("ul.offer-params__list").select("li.offer-params__item");
                    Hashtable<String, String> paramsHashtable = new Hashtable<String, String>();

                    String priceString = pageDoc.select("span.offer-price__number").first().text();
                    if(!priceString.contains(",")) {
                        priceString = priceString.substring(0, priceString.length() - 4);
                        priceString = priceString.replaceAll(" ", "");
                    }else{
                        priceString = priceString.replaceAll(",", "");
                        priceString = priceString.substring(0, priceString.length()-2);
                        priceString = priceString.substring(0, priceString.length() - 4);
                        priceString = priceString.replaceAll(" ", "");
                    }
                    Integer price = Integer.valueOf(priceString);

                    for (Element param : offerParamsList) { //wyciąganie wartości parametrów do tablicy
                        String key = param.select("span.offer-params__label").text();
                        String value = param.select("div.offer-params__value").text();
                        paramsHashtable.put(key, value);
                    }

                    try {
                        String brand = paramsHashtable.get("Marka pojazdu");
                        String model = paramsHashtable.get("Model pojazdu");
                        String version = paramsHashtable.get("Wersja");
                        Integer year = Integer.valueOf(paramsHashtable.get("Rok produkcji"));
                        Integer enginePower = Integer.valueOf(paramsHashtable.get("Moc").split(" ")[0]);
                        String engineCapacityString = paramsHashtable.get("Pojemność skokowa").replaceAll(" ", "");
                        engineCapacityString = engineCapacityString.substring(0, engineCapacityString.length() - 3);
                        Double engineCapacity = Double.valueOf(engineCapacityString);
                        String fuel = paramsHashtable.get("Rodzaj paliwa");
                        String transmission = paramsHashtable.get("Skrzynia biegów");
                        String drive = paramsHashtable.get("Napęd");
                        String bodyType = paramsHashtable.get("Typ");
                        Integer doors = Integer.valueOf(paramsHashtable.get("Liczba drzwi"));
                        Integer seats = Integer.valueOf(paramsHashtable.get("Liczba miejsc"));

                        if(year == null) year = 0;
                        if(version == null) version = "nieokreślono";
                        if(drive == null) drive = "nieokreślono";
                        if(transmission == null) transmission = "nieokreślono";

//                        System.out.println("Samochód: " +
//                                "\nmarka: " + brand +
//                                "\nmodel: " + model +
//                                "\nwersja: " + version +
//                                "\nrok produkcji: " + year +
//                                "\nmoc silnika: " + enginePower +
//                                "\npojemnosc skokoa: " + engineCapacity +
//                                "\nrodzaj paliwa; " + fuel +
//                                "\nskrzynia biegow: " + transmission +
//                                "\nnapęd: " + drive +
//                                "\ntyp nadwozia: " + bodyType +
//                                "\nliczba drzwi: " + doors +
//                                "\nliczba miejsc: " + seats +
//                                "\ncena: " + price);

                        dbService.insert(brand, model, version, year, enginePower, engineCapacity, fuel, transmission, drive, bodyType, doors, seats, price);
                    } catch (Exception e) {
                        System.out.println("Błąd pobierania danych!: " + e.getMessage());
                    }
//            break;
                }else{
                    System.out.println("Oferta promowana. Pomijam. "+element.text());
                }
            }
        }
    }
}
