import java.sql.*;

public class dbService {
    // JDBC driver name and database URL
    static final String JDBC_DRIVER = "com.postgresql.jdbc.Driver";
    static final String DB_URL = "";

    //  Database credentials
    static final String USER = "";
    static final String PASS = "";

    public static void insert(String brand, String model, String version, Integer year, Integer enginePower, Double engineCapacity, String fuel, String transmission, String drive, String bodyType, Integer doors, Integer seats, Integer price) {
        Connection conn = null;
        try{
            conn = DriverManager.getConnection(DB_URL,USER,PASS);

            //najpierw sprwadzac czy takie auto juz jest
            String selectString = "" +
                    "SELECT * " +
                    "FROM car " +
                    "WHERE " +
                    "brand = ? AND " +
                    "model = ? AND " +
                    "version = ? AND " +
                    "engine_power = ? AND " +
                    "engine_capacity = ? AND " +
                    "fuel = ? AND " +
                    "transmission = ? AND " +
                    "drive = ? AND " +
                    "body_type = ? AND " +
                    "doors = ? AND " +
                    "seats = ?";
            PreparedStatement preparedSelect = conn.prepareStatement(selectString);
            preparedSelect.setString(1, brand);
            preparedSelect.setString(2, model);
            preparedSelect.setString(3, version);
            preparedSelect.setInt(4, enginePower);
            preparedSelect.setDouble(5, engineCapacity);
            preparedSelect.setString(6, fuel);
            preparedSelect.setString(7, transmission);
            preparedSelect.setString(8, drive);
            preparedSelect.setString(9, bodyType);
            preparedSelect.setInt(10, doors);
            preparedSelect.setInt(11, seats);

            ResultSet rs = preparedSelect.executeQuery();
            if(rs.next()) {
                try {
                    Long repeatedId = rs.getLong("id");
                    Integer minPrice = rs.getInt("price_from");
                    Integer maxPrice = rs.getInt("price_to");
                    Long priceSum = rs.getLong("price_sum");
                    Long counter = rs.getLong("counter");
                    Double avarage;
                    if (price >= maxPrice) {
                        maxPrice = price;
                    } else {
                        minPrice = price;
                    }
                    priceSum = priceSum + price;
                    counter = counter + 1;
                    avarage = priceSum / (double) counter;

                    //update z nowymi danymi / zmiana tylko 5 parametrow
                    String updateString = "" +
                            "UPDATE car " +
                            "SET price_from = ?, price_to = ?, price_sum = ?, avarage = ?, counter = ? WHERE id = ?";
                    PreparedStatement updatePrepare = conn.prepareStatement(updateString);
                    updatePrepare.setInt(1, minPrice);
                    updatePrepare.setInt(2, maxPrice);
                    updatePrepare.setLong(3, priceSum);
                    updatePrepare.setDouble(4, avarage);
                    updatePrepare.setLong(5, counter);
                    updatePrepare.setLong(6, repeatedId);

                    int rows = updatePrepare.executeUpdate();
                    //zaktualizowano
                    System.out.println("Zauktualizowano: " + brand);
                }catch (Exception e){
                    System.out.println("Błąd podczas aktualizacji ogłoszenia: " + e.getMessage());
                }
            }else{
                String sql = "INSERT INTO car (brand, model, version, year, engine_power, engine_capacity, fuel, transmission, drive, body_type, doors, seats, price_from, price_to, price_sum, counter, avarage) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

                PreparedStatement preparedStatement = conn.prepareStatement(sql);
                preparedStatement.setString(1, brand);
                preparedStatement.setString(2, model);
                preparedStatement.setString(3, version);
                preparedStatement.setInt(4, year);
                preparedStatement.setInt(5, enginePower);
                preparedStatement.setDouble(6, engineCapacity);
                preparedStatement.setString(7, fuel);
                preparedStatement.setString(8, transmission);
                preparedStatement.setString(9, drive);
                preparedStatement.setString(10, bodyType);
                preparedStatement.setInt(11, doors);
                preparedStatement.setInt(12, seats);
                preparedStatement.setInt(13, price);
                preparedStatement.setInt(14, price);
                preparedStatement.setInt(15, price);
                preparedStatement.setInt(16, 1);
                preparedStatement.setDouble(17, price);

                int row = preparedStatement.executeUpdate();
                System.out.println("Dodano: " + brand);

                preparedStatement.close();
                conn.close();
            }
        }catch(SQLException se){
            se.printStackTrace();
        }
    }
}
