package com.cars.car4you.api;

import org.springframework.http.HttpHeaders;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;

@RestController
public class SimpleController {

    @GetMapping("/error")
    public String errorPage() {
        return "error";
    }

    @GetMapping("/")
    public byte[] homePage() throws IOException {
        byte[] array = Files.readAllBytes(Paths.get("src/main/client/html/search.html"));

        return array;
    }

    @GetMapping("/{name}")
    public byte[] getPageByName(@PathVariable String name) throws IOException {
        byte[] array = Files.readAllBytes(Paths.get("src/main/client/html/" + name));

        return array;
    }

    @GetMapping("/{dir}/{name}")
    public ResponseEntity<byte[]> getPageContents(
            @PathVariable String name,
            @PathVariable String dir) throws IOException {

        byte[] array = Files.readAllBytes(Paths.get("src/main/client/html/"+dir+"/"+name));

        HttpHeaders responseHeaders = new HttpHeaders();

        if(name.matches("(.*\\.js)")) {
            responseHeaders.set("Content-Type", "text/javascript");
        }else{
            //dodatkowe content-types
        }

        return ResponseEntity.ok()
                .headers(responseHeaders)
                .body(array);
    }
}