package com.cars.car4you.model;

import com.vladmihalcea.hibernate.type.array.StringArrayType;
import lombok.Data;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.TypeDef;
import org.hibernate.annotations.TypeDefs;

import javax.persistence.*;
import java.util.List;

@Entity
@Data
@Table(name = "car_details")
@TypeDefs(@TypeDef(name = "string-array", typeClass = StringArrayType.class))
public class CarDetails {

//    @OneToMany(mappedBy = "car_details_id")
//    private List<Car> cars;

    @Id
    private Long id;

    @Column(nullable = false, unique = false)
    private String brand;

    @Column(nullable = false, unique = false)
    private String model;

    @Column(nullable = false, unique = false)
    private String version;

    @Column(nullable = true, unique = false)
    private Long price_from;

    @Column(nullable = true, unique = false)
    private Long price_to;

    @Column(nullable = true, unique = false)
    private Long average;

    @Type(type = "string-array" )
    @Column(name = "car_pros")
    private String[] car_pros;

    @Type(type = "string-array" )
    @Column(name = "car_cons")
    private String[] car_cons;

    @Column(nullable = true, unique = false)
    private Double rating;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getBrand() {
        return brand;
    }

    public void setBrand(String brand) {
        this.brand = brand;
    }

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public Long getPrice_from() {
        return price_from;
    }

    public void setPrice_from(Long price_from) {
        this.price_from = price_from;
    }

    public Long getPrice_to() {
        return price_to;
    }

    public void setPrice_to(Long price_to) {
        this.price_to = price_to;
    }

    public Long getAverage() {
        return average;
    }

    public void setAverage(Long average) {
        this.average = average;
    }

    public String[] getCar_pros() {
        return car_pros;
    }

    public void setCar_pros(String[] car_pros) {
        this.car_pros = car_pros;
    }

    public String[] getCar_cons() {
        return car_cons;
    }

    public void setCar_cons(String[] car_cons) {
        this.car_cons = car_cons;
    }

    public Double getRating() {
        return rating;
    }

    public void setRating(Double rating) {
        this.rating = rating;
    }
}
